/*
 * LTSTransition.java
 *
 * Created on 24 July 2007, 21:02
 */

package assignment;

/**
 *
 * @author David
 */
public class LTSTransition {
    protected LTSNode node1;
    protected LTSNode node2;
    protected String name;
    
    /** Creates a new instance of LTSTransition */
    public LTSTransition() {

    }
    
    public LTSTransition(LTSNode _node1, LTSNode _node2, String name) {
        setName(name);
        setNode1(_node1);
        setNode2(_node2);
    }
    
    public String getName() {
        return name;
    }
    
    public void setName(String theName) {
        name = theName;
    }
    
    public LTSNode getNode1() {
        return node1;
    }
    public LTSNode getNode2() {
        return node2;
    }

    public void setNode1(LTSNode theNode){
        node1 = theNode;
    }
    
    public void setNode2(LTSNode theNode) {
        node2 = theNode;
    }
    
    public boolean equals(LTSTransition ltst) {
        if (ltst.getNode1().getName().equals(node1.getName())
            && ltst.getNode2().getName().equals(node2.getName())
            && ltst.getName().equals(name))
            return true;
        else
            return false;
    }
    
    public boolean equals(Object o) {
        try {
            LTSTransition ltst = (LTSTransition) o;
            return equals(ltst);
        }
        catch (Exception e) {
            return false;
        }
    }
    
    public int hashCode() {
        return toString().hashCode();
    }
    
    public String toString() {
        if ((name == "") && (node2 == null))
            return node1.toString();
        else {
            String n1 = node1.toString();
            String n2 = node2.toString();
            
            if (n1.contains(" ") || n1.contains("-") ||
                    n1.contains("|") || n1.contains("=")) {
                n1 = "\"" + n1 + "\"";
            }
            
            if (n2.contains(" ") || n2.contains("-") ||
                    n2.contains("|") || n2.contains("=")) {
                n2 = "\"" + n2 + "\"";
            }            
            
            return n1 + "/" + name + "/" + n2;
        }
        
    }
    
}
